/*
*
*			     I2C   
*
*
*
*
*/

#include	"Hardware.h"


// *****  I2C
void I2C_Init (void) {
/* 
 *  :
 *   .
 *
 *  :
 *   .
 *
*/
	
	
}
//  I2C *****


// *****    I2C
void I2C_Start (void) {
/* 
 *  :
 *   .
 * 
 *  :
 *   .
 *
 *     
 * (      )
*/

	btSDA = 0; // SDA   
}
//    I2C *****


// *****    I2C
void I2C_Restart (void) {
/* 
 *  :
 *   .
 *
 *  :
 *   .
 *
 *     
 * (      )
*/
	
	btSCL = 0; // SCL   
	btSDA = 1; // SDA   
	btSCL = 1; // SCL   
	btSDA = 0; // SDA   
}
//    I2C *****


// *****    I2C
void I2C_Stop (void) {
/* 
 *  :
 *   .
 * 
 *  :
 *   .
 *
 *     
 * (      )
*/

	btSCL = 0; // SCL   
	btSDA = 0; // SDA   
	btSCL = 1; // SCL   
	btSDA = 1; // SDA   
}
//    I2C *****


// *****    I2C
void I2C_SetByte (unsigned char AByte) {
/* 
 *  :
 *   AByte - ,   I2C.
 * 
 *  :
 *   .
 *
 *     
 * (      )
*/
	unsigned char i;

	for(i = 0; i < 8; i++) {
		btSCL = 0; // SCL   
		if (AByte & 0x80)
		{
			btSDA = 1; // SDA   
		}
		else
		{
			btSDA = 0; // SDA   
		}
		AByte <<= 1;
		btSCL = 1; // SCL   
	}
}
//    I2C *****


// *****    I2C
unsigned char I2C_GetByte (void) {
/* 
 *  :
 *   .
 * 
 *  :
 *   .
 *
 * :
 *    .
 *
 *     
 * (      )
*/
	unsigned char i, inbyte;

	inbyte = 0;
	for(i = 0; i < 8; i++) {
		btSCL = 0; // SCL   
		asm ("nop");
		btSCL = 1; // SCL   
		asm ("nop");
		if (bpSDA) inbyte |= 1; //    1
		if (i<7) inbyte <<= 1;
	}
	return inbyte;
}
//    I2C *****


// *****    I2C
void I2C_SetACK (unsigned AACK) {
/* 
 *  :
 *   AACK:
 *        0 -  ,
 *         -  .
 * 
 *  :
 *   .
 *
 *     
 * (      )
*/

	btSCL = 0; // SCL   
	asm("nop");
	if (AACK)
	{
		btSDA = 0; // SDA   
	}
	else
	{
		btSDA = 1; // SDA   
	}
	asm("nop");
	btSCL = 1; // SCL   
}
//    I2C *****


// *****    I2C
unsigned char I2C_GetACK (void) {
/* 
 *  :
 *   .
 * 
 *  :
 *   .
 * 
 * :
 *   0 -  
 *   1 -  
 * 
 *     
 * (      )
*/
	unsigned char i;
	
	i = 0;
	btSCL = 0; // SCL   
	asm("nop");
	btSDA = 1; // SDA   
	asm("nop");
	btSCL = 1; // SCL   
	asm("nop");
	if (bpSDA) i = 1;
	return i;
}
//    I2C *****


// *****     I2C
void I2C_SetClock (void) {
/* 
 *  :
 *   .
 * 
 *  :
 *   .
 *
 *     
 * (      )
*/

	btSCL = 0; // SCL   
	asm("nop");
	btSCL = 1; // SCL   
}
//     I2C *****


