/*
*
*			    I2C
*
*
*
*/


#include	<pic.h>
#include	"Hardware.h"
#include	"I2CTest.h"
#include	"I2C.h"

__CONFIG(UNPROTECT & BORDIS & PWRTEN & WDTDIS & XT & LVPDIS);


//   
unsigned char vTI_1ms;		//   1 
unsigned char vTI_5ms;		//   5 
unsigned char vTI_10ms;		//   10 
unsigned char vTI_50ms;		//   50 
unsigned char vTI_100ms;	//   100 
unsigned char vTI_1s;		//   1 

//   
TIntervalTimersFlags rTIFlags = {0,0,0,0,0,0,0};


// **********************************
// **********  **********

// *****  
void Core_Init (void){
/* 
 *  :
 *   .
 *
 *  :
 *   .
 *
*/
	//  
	INTCON = 0x00;
	ADCON1 = 0x07;
	OPTION = 0x80;
	PSA = 1;
	PORTA = 0b00000000;
	TRISA = 0b11111111;
	PORTB = 0b00000000;
	TRISB = 0b11111111;
	PORTC = 0b00000000;
	TRISC = 0b11111111;
	//  
	TMR0 = cSysInt_Data;
	T0IE = 1;
	PEIE = 1;
} //   *****


// *****   
void Timers_Init (void){
/* 
 *  :
 *   .
 *
 *  :
 *   .
 *
*/
	
	vTI_1ms = cInterval1ms;
	vTI_5ms = cInterval5ms;
	vTI_10ms = cInterval10ms;
	vTI_50ms = cInterval50ms;
	vTI_100ms = cInterval100ms;
	vTI_1s = cInterval1s;
	//vTimeHours = 0;
	//vTimeMinutes = 0;
	//vTimeSeconds = 0;
} //    *****


// **********  **********
// **********************************


// ***** 
interrupt void InterruptHandler (void) {
/* 
 *  :
 *   .
 *
 *  :
 *   .
 *
*/

	// ***  
	//asm ("nop");
	TMR0 += cSysInt_Data;
	TMR0IF = 0;
	//   ***
	// ***   
	rTIFlags.ISys = 1;
	vTI_1ms --;
	if (vTI_1ms == 0) {
		vTI_1ms = cInterval1ms;
		rTIFlags.I1ms = 1;
	}
	vTI_10ms --;
	if (vTI_10ms == 0) {
		vTI_10ms = cInterval10ms;
		rTIFlags.I10ms = 1;
		vTI_50ms --;
		if (vTI_50ms == 0) {
			vTI_50ms = cInterval50ms;
			rTIFlags.I50ms = 1;
		}
		vTI_1s --;
		if (vTI_1s == 0) {
			vTI_1s = cInterval1s;
			rTIFlags.I1s = 1;
		}
	}
	//    ***

	// ***   
	//    ***
	
} //  *****


// *****  
void main (void) {
/* 
 *  :
 *   .
 *
 *  :
 *   .
 *
*/
	unsigned char ReadByte, i;
	signed char Temp;
	unsigned char WriteByte;
	unsigned int Delay;


	// * 
	Core_Init();
	Timers_Init();
	I2C_Init();
	//  *
	//GIE = 1;

	//   
	I2C_Start(); //  
	I2C_SetByte(0xA2); //  / ,      (A2 - 1010 001 0)
	I2C_GetACK(); //  
	I2C_SetByte(0x00); //    
	I2C_GetACK(); //  
	for (i = 0; i<16; i++) {
		I2C_SetByte(i+5); //  
		I2C_GetACK(); //  
	}
	I2C_Stop(); //  

	for (Delay = 0; Delay < 2000; Delay++) {} //     EEPROM

	//   
	I2C_Start(); //  
	I2C_SetByte(0xA2); //  / ,      (A2 - 1010 001 0)
	I2C_GetACK(); //  
	I2C_SetByte(0x00); //    
	I2C_GetACK(); //  
	I2C_Restart(); //  
	I2C_SetByte(0xA3); //  / ,      (A3 - 1010 001 1)
	I2C_GetACK(); //  
	for (i = 0; i<16; i++) {
		ReadByte = I2C_GetByte(); //  
		I2C_SetACK(1); //  
	}
	I2C_Stop(); //  

//	//   
//	I2C_Start(); //  
//	I2C_SetByte(0xA2); //  / ,      (A2 - 1010 001 0)
//	I2C_GetACK(); //  
//	I2C_SetByte(0x00); //    
//	I2C_GetACK(); //  
//	I2C_Restart(); //  
//	I2C_SetByte(0xA3); //  / ,      (A3 - 1010 001 1)
//	I2C_GetACK(); //  
//	ReadByte = I2C_GetByte(); //  
//	I2C_SetACK(0); //  
//	I2C_Stop(); //  
//	
//	I2C_Start(); //  
//	I2C_SetByte(0xA2); //  / ,      (A2 - 1010 001 0)
//	I2C_GetACK(); //  
//	I2C_SetByte(0x01); //    
//	I2C_GetACK(); //  
//	I2C_Restart(); //  
//	I2C_SetByte(0xA3); //  / ,      (A3 - 1010 001 1)
//	I2C_GetACK(); //  
//	ReadByte = I2C_GetByte(); //  
//	I2C_SetACK(0); //  
//	I2C_Stop(); //  
//	
//	for (Delay = 0; Delay < 1000; Delay++) {} // 
//	I2C_Start(); //  
//	I2C_SetByte(0xA3); //  / ,      (A3 - 1010 001 1)
//	I2C_GetACK(); //  
//	for (i = 0; i<16; i++) {
//		ReadByte = I2C_GetByte(); //  
//		I2C_SetACK(1); //  
//	}
//	I2C_Stop(); //  

	// *  
	for (;;) {

	} //   *
} //   *****
